From 31ad3b93d5ebc4ed093be487d41309cf87c2cc90 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: May 04 2017 22:05:20 +0000
Subject: [PATCH 831/1001] Tests: hubs.app.app is now safe to use


---

diff --git a/hubs/tests/__init__.py b/hubs/tests/__init__.py
index 0fd3ba9..729db65 100644
--- a/hubs/tests/__init__.py
+++ b/hubs/tests/__init__.py
@@ -179,9 +179,7 @@ def captured_templates(app):
     usage.
 
     The argument is the signal emitter.  When calling a core Hubs view, this is
-    the Hubs app (``hubs.app.app`` or ``self.app.application`` if you're in an
-    :py:class:`APPTest` subclass).  If you're calling a widget view, the signal
-    emitter is the widget class, as found in the widgets registry.
+    the Hubs app (``hubs.app.app``).
 
     Args:
         app: The signal emitter.
diff --git a/hubs/tests/test_authz.py b/hubs/tests/test_authz.py
index ec607de..7a7c85a 100644
--- a/hubs/tests/test_authz.py
+++ b/hubs/tests/test_authz.py
@@ -1,5 +1,6 @@
 from __future__ import absolute_import, unicode_literals
 
+from hubs.app import app
 from hubs.authz import ObjectAuthzMixin, AccessLevel, PERMISSIONS
 from hubs.tests import APPTest, FakeAuthorization
 
@@ -18,10 +19,14 @@ class TestObj(ObjectAuthzMixin):
 
 class AuthzTestCase(APPTest):
 
-    def run(self, *args, **kwargs):
-        import hubs.app
-        with hubs.app.app.app_context():
-            super(AuthzTestCase, self).run(*args, **kwargs)
+    def setUp(self):
+        super(AuthzTestCase, self).setUp()
+        self.app_context = app.app_context()
+        self.app_context.__enter__()
+
+    def tearDown(self):
+        self.app_context.__exit__(None, None, None)
+        super(AuthzTestCase, self).tearDown()
 
     def test_mixin_access_level_anonymous(self):
         obj = TestObj()
diff --git a/hubs/tests/test_view_utils.py b/hubs/tests/test_view_utils.py
index 0101299..d445c28 100644
--- a/hubs/tests/test_view_utils.py
+++ b/hubs/tests/test_view_utils.py
@@ -1,21 +1,30 @@
 from __future__ import unicode_literals
 
 import hubs.models
+from hubs.app import app
 from hubs.tests import APPTest, FakeAuthorization, auth_set
 from hubs.views.utils import get_visible_widgets
 
 
 class ViewUtilsTest(APPTest):
 
+    def setUp(self):
+        super(ViewUtilsTest, self).setUp()
+        self.app_context = app.app_context()
+        self.app_context.__enter__()
+
+    def tearDown(self):
+        self.app_context.__exit__(None, None, None)
+        super(ViewUtilsTest, self).tearDown()
+
     def test_removed_widget(self):
         hub = hubs.models.Hub.get("ralph")
         widget = hubs.models.Widget(
             hub=hub, plugin="does-not-exist",
             left=True, index=-1, _config="{}")
         self.session.add(widget)
-        with auth_set(self.app.application, FakeAuthorization('ralph')):
-            with self.app.application.app_context():
-                widgets = get_visible_widgets(hub)
+        with auth_set(app, FakeAuthorization('ralph')):
+            widgets = get_visible_widgets(hub)
         self.assertNotIn(
             "does-not-exist", [w.plugin for w in widgets["left"]])
         widget.left = False
@@ -24,9 +33,8 @@ class ViewUtilsTest(APPTest):
 
     def test_get_visible_widgets(self):
         hub = hubs.models.Hub.get('ralph')
-        with auth_set(self.app.application, None):
-            with self.app.application.app_context():
-                widgets = get_visible_widgets(hub)
+        with auth_set(app, None):
+            widgets = get_visible_widgets(hub)
         self.assertListEqual(
             [w.plugin for w in widgets["left"]],
             ["feed"])
@@ -48,15 +56,13 @@ class ViewUtilsTest(APPTest):
         meetings.visibility = "restricted"
         # Restricted widgets in preview hubs aren't displayed to
         # anonymous users.
-        with auth_set(self.app.application, None):
-            with self.app.application.app_context():
-                widgets = get_visible_widgets(hub)
+        with auth_set(app, None):
+            widgets = get_visible_widgets(hub)
         self.assertNotIn(
             "meetings", [w.plugin for w in widgets["right"]])
         # But they are displayed to members.
-        with auth_set(self.app.application, FakeAuthorization('ralph')):
-            with self.app.application.app_context():
-                widgets = get_visible_widgets(hub)
+        with auth_set(app, FakeAuthorization('ralph')):
+            widgets = get_visible_widgets(hub)
         self.assertIn(
             "meetings", [w.plugin for w in widgets["right"]])
 
@@ -69,14 +75,12 @@ class ViewUtilsTest(APPTest):
         assert meetings.left is False
         # Widgets in private hubs aren't displayed to
         # anonymous users.
-        with auth_set(self.app.application, None):
-            with self.app.application.app_context():
-                widgets = get_visible_widgets(hub)
+        with auth_set(app, None):
+            widgets = get_visible_widgets(hub)
         self.assertEqual(widgets["left"], [])
         self.assertEqual(widgets["right"], [])
         # But they are displayed to members.
-        with auth_set(self.app.application, FakeAuthorization('ralph')):
-            with self.app.application.app_context():
-                widgets = get_visible_widgets(hub)
+        with auth_set(app, FakeAuthorization('ralph')):
+            widgets = get_visible_widgets(hub)
         self.assertNotEqual(len(widgets["left"]), 0)
         self.assertNotEqual(len(widgets["right"]), 0)
diff --git a/hubs/tests/test_widget_base.py b/hubs/tests/test_widget_base.py
index 53d1bf8..832c2f8 100644
--- a/hubs/tests/test_widget_base.py
+++ b/hubs/tests/test_widget_base.py
@@ -1,14 +1,14 @@
 from __future__ import unicode_literals
 
 import six
+from mock import Mock
 
+from hubs.app import app
+from hubs.tests import APPTest
 from hubs.widgets.base import Widget
 from hubs.widgets.caching import CachedFunction
 from hubs.widgets.view import WidgetView
 
-from mock import Mock
-from hubs.tests import APPTest
-
 
 class TestingWidget(Widget):
     name = "testing"
@@ -28,14 +28,14 @@ class WidgetTest(APPTest):
         super(WidgetTest, self).setUp()
         # Backup the URL map
         self._old_url_map = (
-            self.app.application.url_map._rules[:],
-            self.app.application.url_map._rules_by_endpoint.copy()
+            app.url_map._rules[:],
+            app.url_map._rules_by_endpoint.copy()
             )
 
     def tearDown(self):
         # Restore the URL map
-        self.app.application.url_map._rules = self._old_url_map[0]
-        self.app.application.url_map._rules_by_endpoint = self._old_url_map[1]
+        app.url_map._rules = self._old_url_map[0]
+        app.url_map._rules_by_endpoint = self._old_url_map[1]
         super(WidgetTest, self).tearDown()
 
     def test_validate(self):
@@ -126,23 +126,17 @@ class WidgetTest(APPTest):
             "root": TestView1(testing_widget),
             "test2": TestView2(testing_widget),
         }
-        testing_widget.register_routes(self.app.application)
+        testing_widget.register_routes(app)
         # TestView1
-        self.assertIn("testing_root",
-                      self.app.application.url_map._rules_by_endpoint)
-        self.assertIn("testing_root", self.app.application.view_functions)
-        rules = list(
-            self.app.application.url_map.iter_rules(endpoint="testing_root")
-            )
+        self.assertIn("testing_root", app.url_map._rules_by_endpoint)
+        self.assertIn("testing_root", app.view_functions)
+        rules = list(app.url_map.iter_rules(endpoint="testing_root"))
         self.assertEqual(len(rules), 2)
         self.assertEqual(rules[0].rule, "/<hub>/w/testing/<int:idx>/")
         self.assertEqual(rules[1].rule, "/<hub>/w/testing/<int:idx>/test-1/")
         # TestView2
-        self.assertIn("testing_test2",
-                      self.app.application.url_map._rules_by_endpoint)
-        self.assertIn("testing_test2", self.app.application.view_functions)
-        rules = list(
-            self.app.application.url_map.iter_rules(endpoint="testing_test2")
-            )
+        self.assertIn("testing_test2", app.url_map._rules_by_endpoint)
+        self.assertIn("testing_test2", app.view_functions)
+        rules = list(app.url_map.iter_rules(endpoint="testing_test2"))
         self.assertEqual(len(rules), 1)
         self.assertEqual(rules[0].rule, "/<hub>/w/testing/<int:idx>/test-2")
diff --git a/hubs/tests/widgets/test_halp.py b/hubs/tests/widgets/test_halp.py
index ed60356..a9d296d 100644
--- a/hubs/tests/widgets/test_halp.py
+++ b/hubs/tests/widgets/test_halp.py
@@ -2,6 +2,7 @@ from __future__ import unicode_literals, absolute_import
 
 import json
 
+from hubs.app import app
 from hubs.models import Hub, User
 from hubs.tests import FakeAuthorization
 from hubs.widgets import registry
@@ -341,7 +342,7 @@ class HalpFunctionsTestCase(WidgetTest):
         self.session.commit()
 
     def test_execute(self):
-        with self.app.application.test_request_context('/'):
+        with app.test_request_context('/'):
             result = self.func.execute()
         self.assertEqual(result, SAMPLE_DATA)
 
@@ -379,7 +380,7 @@ class PaginateTestCase(WidgetTest):
         self.values = ["A", "B", "C", "D"]
 
     def test_base(self):
-        with self.app.application.test_request_context('/'):
+        with app.test_request_context('/'):
             result = self.paginate(self.values, 3)
         self.assertListEqual(result[0], self.values[:3])
         self.assertDictEqual(result[1], {
@@ -391,7 +392,7 @@ class PaginateTestCase(WidgetTest):
             })
 
     def test_page_2(self):
-        with self.app.application.test_request_context('/?page=2'):
+        with app.test_request_context('/?page=2'):
             result = self.paginate(self.values, 3)
         self.assertListEqual(result[0], self.values[3:])
         self.assertDictEqual(result[1], {
@@ -403,7 +404,7 @@ class PaginateTestCase(WidgetTest):
             })
 
     def test_page_0(self):
-        with self.app.application.test_request_context('/?page=0'):
+        with app.test_request_context('/?page=0'):
             result = self.paginate(self.values, 3)
         self.assertListEqual(result[0], self.values[:3])
         self.assertDictEqual(result[1], {
@@ -415,7 +416,7 @@ class PaginateTestCase(WidgetTest):
             })
 
     def test_invalid_page(self):
-        with self.app.application.test_request_context('/?page=blah'):
+        with app.test_request_context('/?page=blah'):
             result = self.paginate(self.values, 3)
         self.assertListEqual(result[0], self.values[:3])
         self.assertDictEqual(result[1], {
@@ -427,7 +428,7 @@ class PaginateTestCase(WidgetTest):
             })
 
     def test_page_too_high(self):
-        with self.app.application.test_request_context('/?page=3'):
+        with app.test_request_context('/?page=3'):
             result = self.paginate(self.values, 3)
         self.assertListEqual(result[0], self.values[3:])
         self.assertDictEqual(result[1], {
@@ -440,7 +441,7 @@ class PaginateTestCase(WidgetTest):
 
     def test_single_page(self):
         values = self.values[:3]
-        with self.app.application.test_request_context('/'):
+        with app.test_request_context('/'):
             result = self.paginate(values, 3)
         self.assertListEqual(result[0], values)
         self.assertDictEqual(result[1], {
@@ -453,7 +454,7 @@ class PaginateTestCase(WidgetTest):
 
     def test_no_value(self):
         values = []
-        with self.app.application.test_request_context('/'):
+        with app.test_request_context('/'):
             result = self.paginate(values, 3)
         self.assertListEqual(result[0], [])
         self.assertDictEqual(result[1], {

